package ch.lantersoft.layeredPaneExperiment;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;

public class ColorPanel extends JPanel {

	private static final long serialVersionUID = -8933814415954490108L;
	private JLabel label;

	public ColorPanel(Color color, final LpExperiment par) {
		label = new JLabel("Nr. x");
		float hsb[] = new float[3];
		Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(),hsb);
		if (hsb[2] < .5f) {
			setForeground(Color.GRAY);
			label.setForeground(Color.GRAY);
		}
		setFont(new Font(Font.SANS_SERIF,Font.PLAIN,20));
		setBackground(color);
		setPreferredSize(new Dimension(80,120));
		setBorder(new LineBorder(Color.BLACK));
		addMouseListener(new DefaultMousePolicy(par,this));
		add(label);
	}
	
	public void setText(String text) { // delegate
		label.setText(text);
	}

	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		String s = ""+getParent().getComponentZOrder(this);
		int w = g.getFontMetrics().stringWidth(s);
		int h = getFont().getSize();
		g.drawString(s, (getWidth()-w)/2, (getHeight()+h)/2);
	}
}
