package ch.lantersoft.layeredPaneExperiment;

import java.awt.BorderLayout;

import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.border.EtchedBorder;

public class Main extends JApplet {

	private static final long serialVersionUID = 1L;

	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				Config config = new Config();
				LpExperiment pane = new LpExperiment(config);
				PnlControl pnlControl = new PnlControl(config,pane);
				
				JPanel pnl = new JPanel(new BorderLayout());
				pnl.add(pnlControl,BorderLayout.NORTH);
				pnl.add(pane,BorderLayout.CENTER);
				pnl.setBorder(new EtchedBorder(EtchedBorder.RAISED));
				
				JFrame frame = new JFrame("LayeredPane Experiment");
				frame.add(pnl);
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setSize(480,400);
				frame.setLocation(500,200);
				frame.setVisible(true);
				pane.repaint();
			}
		});
	}
	
	public void init() {
		Config config = new Config();
		LpExperiment pane = new LpExperiment(config);
		PnlControl control = new PnlControl(config,pane);
		
		JPanel pnl = new JPanel(new BorderLayout());
		pnl.add(control,BorderLayout.NORTH);
		pnl.add(pane,BorderLayout.CENTER);
		pnl.setBorder(new EtchedBorder(EtchedBorder.RAISED));
		add(pnl);
	}
}
