package ch.lantersoft.layeredPaneExperiment;

import info.clearthought.layout.TableLayout;

import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.text.DecimalFormat;

import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

public class PnlControl extends JPanel {

	private static final long serialVersionUID = -6036351121845495740L;

	public PnlControl(final Config config, final LpExperiment layeredPane) {
		
		TableLayout layout = new TableLayout();
		setLayout(layout);
		setBackground(new Color(153,217,234));

		double p = TableLayout.PREFERRED;
		layout.setRow(new double[] {p,p,10,p,5} );
		layout.setColumn(new double[] {TableLayout.FILL,p,p,30,p,p,TableLayout.FILL} );

		final JFormattedTextField txfTime = new JFormattedTextField(new DecimalFormat("#"));
		txfTime.setText(""+config.time);
		txfTime.setColumns(6);

		final JFormattedTextField txfPane = new JFormattedTextField(new DecimalFormat("#"));
		txfPane.setText(""+config.panes);
		txfPane.setColumns(6);

		final JFormattedTextField txfBtns = new JFormattedTextField(new DecimalFormat("#"));
		txfBtns.setText(""+config.buttons);
		txfBtns.setColumns(6);

		final JFormattedTextField txfShrink = new JFormattedTextField(new DecimalFormat("0.###"));
		txfShrink.setText(""+config.shrinkfactor);
		txfShrink.setColumns(6);

		JButton btnNew = new JButton("Restart");
		JButton btnPnl = new JButton("Add panel");
		JButton btnBtn = new JButton("Add button");
		JPanel pnl = new JPanel(new GridLayout(1,3,5,5));
		pnl.setOpaque(false);
		pnl.add(btnPnl);
		pnl.add(btnBtn);
		pnl.add(btnNew);

		add(new JLabel("Duration: "),"1,0");
		add(txfTime,"2,0");
		add(new JLabel("Amplitude: "),"1,1");
		add(txfShrink,"2,1");
		add(new JLabel("Color-panels: "),"4,0");
		add(txfPane,"5,0");
		add(new JLabel("Buttons: "),"4,1");
		add(txfBtns,"5,1");
		add(pnl,"1,3,5,3,C,C");

		setBorder(new EmptyBorder(5,5,5,5));

		txfTime.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent event) {
				String str = txfTime.getText();
				if (!str.isEmpty()) {
					try {
						config.time = Integer.parseInt(str);
						if (config.time<0) config.time = 0;
					} catch (Exception e) {
						config.time = 500;
					}
				}
			}
		});

		txfPane.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent event) {
				String str = txfPane.getText();
				if (!str.isEmpty()) {
					try {
						config.panes = Integer.parseInt(str);
						if (config.panes<0) config.panes = 0;
					} catch (Exception e) {
						config.panes = 10;
					}
				}
			}
		});

		txfBtns.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent event) {
				String str = txfBtns.getText();
				if (!str.isEmpty()) {
					try {
						config.buttons = Integer.parseInt(str);
						if (config.buttons<0) config.buttons = 0;
					} catch (Exception e) {
						config.buttons = 0;
					}
				}
			}
		});

		txfShrink.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent event) {
				String str = txfShrink.getText();
				if (str.startsWith("."));
				str = "0"+str;
				if (!str.isEmpty()) {
					try {
						config.shrinkfactor = Float.parseFloat(str);
						if (config.shrinkfactor<0) config.shrinkfactor = 0;
					} catch (Exception e) {
						config.shrinkfactor = 0;
					}
				}
			}
		});

		btnNew.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				new Thread(new Runnable() {
					public void run() {
						layeredPane.clear();
						try { Thread.sleep(config.time+1); } catch (InterruptedException e) { e.printStackTrace(); }
						layeredPane.start();
					}
				}).start();
			}
		});

		btnPnl.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				if (layeredPane!=null) {
					layeredPane.addNewPanel();
				}
			}
		});

		btnBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				if (layeredPane!=null) {
					layeredPane.addNewButton();
				}
			}
		});
	}
}